/**
 * 
 */
package org.foo.bar.mongo.service;

import org.foo.bar.mongo.domain.User;
import org.foo.bar.mongo.repository.UserRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;

/**
 * @author ctranxuan
 *
 */
public interface UserService {

    /**
     * @param aEntity
     * @return
     * @see org.springframework.data.repository.CrudRepository#save(java.lang.Object)
     */
    <S extends User> S save(S aEntity);

    /**
     * @param aSort
     * @return
     * @see org.springframework.data.repository.PagingAndSortingRepository#findAll(org.springframework.data.domain.Sort)
     */
    Iterable<User> findAll(Sort aSort);

    /**
     * @param aEntities
     * @return
     * @see org.springframework.data.repository.CrudRepository#save(java.lang.Iterable)
     */
    <S extends User> Iterable<S> save(Iterable<S> aEntities);

    /**
     * @param aPageable
     * @return
     * @see org.springframework.data.repository.PagingAndSortingRepository#findAll(org.springframework.data.domain.Pageable)
     */
    Page<User> findAll(Pageable aPageable);

    /**
     * @param aId
     * @return
     * @see org.springframework.data.repository.CrudRepository#findOne(java.io.Serializable)
     */
    User findOne(String aId);

    /**
     * @param aId
     * @return
     * @see org.springframework.data.repository.CrudRepository#exists(java.io.Serializable)
     */
    boolean exists(String aId);

    /**
     * @return
     * @see org.springframework.data.repository.CrudRepository#findAll()
     */
    Iterable<User> findAll();

    /**
     * @param aIds
     * @return
     * @see org.springframework.data.repository.CrudRepository#findAll(java.lang.Iterable)
     */
    Iterable<User> findAll(Iterable<String> aIds);

    /**
     * @return
     * @see org.springframework.data.repository.CrudRepository#count()
     */
    long count();

    /**
     * @param aId
     * @see org.springframework.data.repository.CrudRepository#delete(java.io.Serializable)
     */
    void delete(String aId);

    /**
     * @param aEntity
     * @see org.springframework.data.repository.CrudRepository#delete(java.lang.Object)
     */
    void delete(User aEntity);

    /**
     * @param aEntities
     * @see org.springframework.data.repository.CrudRepository#delete(java.lang.Iterable)
     */
    void delete(Iterable<? extends User> aEntities);

    /**
     * 
     * @see org.springframework.data.repository.CrudRepository#deleteAll()
     */
    void deleteAll();

    /**
     * @return the userRepository
     */
    UserRepository getUserRepository();

    /**
     * @param aUserRepository
     *            the userRepository to set
     */
    void setUserRepository(UserRepository aUserRepository);

}