package org.foo.bar.mysql;

import java.util.Hashtable;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;
import org.osgi.service.jdbc.DataSourceFactory;

/**
 * Creates a {@link DataSourceFactory} for each of the available Derby JDBC
 * driver types.
 */
public final class Activator implements BundleActivator {

    private ServiceRegistration clientService;

    @Override
    public void start(final BundleContext context) throws Exception {
        System.out.println("Starting Gemini DBAccess MySQL");
        Hashtable<String, String> props = new Hashtable<String, String>();
        props.put(DataSourceFactory.OSGI_JDBC_DRIVER_NAME, DataSourceFactoryConstants.MYSQL_DRIVER_NAME);

        /* === Register the JDBC 3 drivers === */
        props.put(DataSourceFactory.OSGI_JDBC_DRIVER_VERSION, DataSourceFactoryConstants.JDBC_3_DRIVER_VERSION);

        // Register the client driver
        props.put(DataSourceFactory.OSGI_JDBC_DRIVER_CLASS, DataSourceFactoryConstants.MYSQL_DRIVER_CLASS);
        clientService = context.registerService(DataSourceFactory.class.getName(),
                new org.foo.bar.mysql.MysqlDataSourceFactory(), props);

    }

    @Override
    public void stop(final BundleContext context) throws Exception {
        System.out.println("Stopping Gemini DBAccess MySQL");
        if (clientService != null) {
            clientService.unregister();
        }
    }
}
